Index: package_tags/xvm-prodconfig/0.9/debian/changelog
===================================================================
--- package_tags/xvm-prodconfig/0.9/debian/changelog	(revision 1000)
+++ package_tags/xvm-prodconfig/0.9/debian/changelog	(revision 1000)
@@ -0,0 +1,60 @@
+xvm-prodconfig (0.9) unstable; urgency=low
+
+  * Add dns section, even though it's something of a lie
+
+ -- Evan Broder <broder@mit.edu>  Thu, 02 Oct 2008 08:07:05 -0400
+
+xvm-prodconfig (0.8) unstable; urgency=low
+
+  * add console section
+
+ -- Greg Price <price@mit.edu>  Wed, 01 Oct 2008 19:53:30 -0400
+
+xvm-prodconfig (0.7) unstable; urgency=low
+
+  * Replace citadel-station with shadow-moses and arklay-mansion as hosts
+    while we get those two up
+
+ -- Evan Broder <broder@mit.edu>  Wed, 01 Oct 2008 19:30:23 -0400
+
+xvm-prodconfig (0.6) unstable; urgency=low
+
+  * Add remote section
+
+ -- Evan Broder <broder@mit.edu>  Wed, 01 Oct 2008 12:04:18 -0400
+
+xvm-prodconfig (0.5) unstable; urgency=low
+
+  * fix distribution
+
+ -- Greg Price <price@mit.edu>  Tue, 30 Sep 2008 23:46:46 -0400
+
+xvm-prodconfig (0.4) hardy; urgency=low
+
+  * add web, svn, trac sections
+
+ -- Greg Price <price@mit.edu>  Mon, 29 Sep 2008 06:03:03 +0000
+
+xvm-prodconfig (0.3ubuntu1) hardy; urgency=low
+
+  * Add some system-vm xen configs.
+
+ -- Greg Price <price@mit.edu>  Mon, 29 Sep 2008 01:56:00 +0000
+
+xvm-prodconfig (0.3) unstable; urgency=low
+
+  * Include a copy of the apt key; currently not automatically installed.
+
+ --  Sam Hartman <hartmans@xvm.mit.edu>  Sun, 24 Aug 2008 20:51:34 +0000
+
+xvm-prodconfig (0.2) unstable; urgency=low
+
+  * Fix script names
+
+ -- Sam Hartman <hartmans@debian.org>  Fri, 22 Aug 2008 16:47:43 -0400
+
+xvm-prodconfig (0.1) unstable; urgency=low
+
+  * Initial prodconfig release
+
+ -- Sam Hartman <hartmans@debian.org>  Fri, 22 Aug 2008 16:40:35 -0400
Index: package_tags/xvm-prodconfig/0.9/debian/compat
===================================================================
--- package_tags/xvm-prodconfig/0.9/debian/compat	(revision 1000)
+++ package_tags/xvm-prodconfig/0.9/debian/compat	(revision 1000)
@@ -0,0 +1,1 @@
+5
Index: package_tags/xvm-prodconfig/0.9/debian/control
===================================================================
--- package_tags/xvm-prodconfig/0.9/debian/control	(revision 1000)
+++ package_tags/xvm-prodconfig/0.9/debian/control	(revision 1000)
@@ -0,0 +1,14 @@
+Source: xvm-prodconfig
+Section: servers
+Priority: important
+Maintainer: xvm@mit.edu
+Build-Depends: cdbs (>= 0.4.23-1.1), debhelper (>= 5)
+Standards-Version: 3.7.2
+
+Package: xvm-prodconfig
+Architecture: all
+Provides: invirt-config
+Conflicts: invirt-config
+Depends: ${shlibs:Depends}, ${misc:Depends}, sipb-xen-base
+Description: XVM dev-cluster config
+  This is the master configuration package for the XVM development cluster.
Index: package_tags/xvm-prodconfig/0.9/debian/copyright
===================================================================
--- package_tags/xvm-prodconfig/0.9/debian/copyright	(revision 1000)
+++ package_tags/xvm-prodconfig/0.9/debian/copyright	(revision 1000)
@@ -0,0 +1,4 @@
+This package was created for the XVM project <xvm@mit.edu> of the MIT
+Student Information Processing Board.
+
+You may use it, etc, under the GNU GPL, version 2 or later.
Index: package_tags/xvm-prodconfig/0.9/debian/rules
===================================================================
--- package_tags/xvm-prodconfig/0.9/debian/rules	(revision 1000)
+++ package_tags/xvm-prodconfig/0.9/debian/rules	(revision 1000)
@@ -0,0 +1,5 @@
+#!/usr/bin/make -f
+
+
+
+include /usr/share/cdbs/1/rules/debhelper.mk
Index: package_tags/xvm-prodconfig/0.9/debian/xvm-prodconfig.install
===================================================================
--- package_tags/xvm-prodconfig/0.9/debian/xvm-prodconfig.install	(revision 1000)
+++ package_tags/xvm-prodconfig/0.9/debian/xvm-prodconfig.install	(revision 1000)
@@ -0,0 +1,1 @@
+files/* .
Index: package_tags/xvm-prodconfig/0.9/debian/xvm-prodconfig.postinst
===================================================================
--- package_tags/xvm-prodconfig/0.9/debian/xvm-prodconfig.postinst	(revision 1000)
+++ package_tags/xvm-prodconfig/0.9/debian/xvm-prodconfig.postinst	(revision 1000)
@@ -0,0 +1,41 @@
+#!/bin/sh
+# postinst script
+#
+# see: dh_installdeb(1)
+
+set -e
+set -x
+
+# summary of how this script can be called:
+#        * <postinst> `configure' <most-recently-configured-version>
+#        * <old-postinst> `abort-upgrade' <new version>
+#        * <conflictor's-postinst> `abort-remove' `in-favour' <package>
+#          <new-version>
+#        * <postinst> `abort-remove'
+#        * <deconfigured's-postinst> `abort-deconfigure' `in-favour'
+#          <failed-install-package> <version> `removing'
+#          <conflicting-package> <version>
+# for details, see http://www.debian.org/doc/debian-policy/ or
+# the debian-policy package
+
+
+case "$1" in
+    configure)
+	/usr/sbin/invirt-reload
+    ;;
+
+    abort-upgrade|abort-remove|abort-deconfigure)
+    ;;
+
+    *)
+        echo "postinst called with unknown argument \`$1'" >&2
+        exit 1
+    ;;
+esac
+
+# dh_installdeb will replace this with shell code automatically
+# generated by other debhelper scripts.
+
+#DEBHELPER#
+
+exit 0
Index: package_tags/xvm-prodconfig/0.9/files/etc/invirt/master.yaml
===================================================================
--- package_tags/xvm-prodconfig/0.9/files/etc/invirt/master.yaml	(revision 1000)
+++ package_tags/xvm-prodconfig/0.9/files/etc/invirt/master.yaml	(revision 1000)
@@ -0,0 +1,56 @@
+authn:
+ - type: kerberos
+   realm: ATHENA.MIT.EDU
+
+authz:
+ - type: afs
+   cell: athena.mit.edu
+
+hosts: # hosts on which VMs run
+ - hostname: shadow-moses.mit.edu
+   ip: 18.181.0.223
+ - hostname: arklay-mansion.mit.edu
+   ip: 18.181.0.224
+
+apt:
+ keyid: 35AE3C4F
+
+db:
+ uri: postgres://sipb-xen@xvm-2.mit.edu/sipb_xen
+ host: xvm-2.mit.edu
+ ip: 18.181.0.80
+ port: 5432
+ user: sipb-xen
+ dbname: sipb_xen
+
+remote:
+ hostname: scored.mit.edu
+ ip: 18.181.0.97
+
+dns:
+ contact: xvm@mit.edu
+ domains: # first one is advertised
+  - xvm.mit.edu
+ nameservers:
+  - hostname: xvm-2.mit.edu
+    ip: 18.181.0.80
+
+web:
+ baseuri: https://xvm-2.mit.edu/
+ hostname: xvm-2.mit.edu
+ errormail: xvm@mit.edu
+ adminacl: system:xvm-root
+ errormail_exclude:
+  - price
+  - ecprice
+  - andersk
+
+console:
+ hostname: ss3.mit.edu
+ ip: 18.181.0.42
+
+svn:
+ repopath: /afs/sipb.mit.edu/project/xvm/svn
+
+trac:
+ uri: https://xvm.mit.edu/trac/wiki
Index: package_tags/xvm-prodconfig/0.9/files/etc/xen/sysvms/ss3.mit.edu
===================================================================
--- package_tags/xvm-prodconfig/0.9/files/etc/xen/sysvms/ss3.mit.edu	(revision 1000)
+++ package_tags/xvm-prodconfig/0.9/files/etc/xen/sysvms/ss3.mit.edu	(revision 1000)
@@ -0,0 +1,42 @@
+
+# Configuration file for the Xen instance ss3.mit.edu, created
+# by xen-tools 3.8 on Sun Sep 28 20:42:38 2008.
+#
+
+#
+#  Kernel + memory size
+#
+kernel      = '/boot/vmlinuz-2.6.24-19-xen'
+ramdisk     = '/boot/initrd.img-2.6.24-19-xen'
+memory      = '128'
+
+#
+#  Disk device(s).
+#
+disk        = [
+                  ',hda1,w',
+              ]
+
+
+#
+#  Hostname
+#
+name        = 'ss3.mit.edu'
+
+#
+#  Networking
+#
+vif         = [ 'ip=18.181.0.42,mac=00:16:3E:7E:E4:DE' ]
+
+#
+#  Behaviour
+#
+on_poweroff = 'destroy'
+on_reboot   = 'restart'
+on_crash    = 'restart'
+
+extra = '2 console=xvc0'
+
+
+disk = ['phy:xenvg/s_console_hda,hda,w']
+root = '/dev/hda1 ro'
Index: package_tags/xvm-prodconfig/0.9/files/etc/xen/sysvms/ss4.mit.edu
===================================================================
--- package_tags/xvm-prodconfig/0.9/files/etc/xen/sysvms/ss4.mit.edu	(revision 1000)
+++ package_tags/xvm-prodconfig/0.9/files/etc/xen/sysvms/ss4.mit.edu	(revision 1000)
@@ -0,0 +1,40 @@
+
+# Configuration file for the Xen instance ss4.mit.edu, created
+# by xen-tools 3.8 on Sun Sep 28 19:53:27 2008.
+#
+
+#
+#  Kernel + memory size
+#
+kernel      = '/boot/vmlinuz-2.6.24-19-xen'
+ramdisk     = '/boot/initrd.img-2.6.24-19-xen'
+memory      = '128'
+
+#
+#  Disk device(s).
+#
+disk        = [
+                  'phy:xenvg/s_remote_hda,hda,w',
+              ]
+root = "/dev/hda1 ro"
+
+#
+#  Hostname
+#
+name        = 'ss4.mit.edu'
+
+#
+#  Networking
+#
+vif         = [ 'ip=18.181.0.44,mac=00:16:3E:7F:C2:55' ]
+
+#
+#  Behaviour
+#
+on_poweroff = 'destroy'
+on_reboot   = 'restart'
+on_crash    = 'restart'
+
+extra = '2 console=xvc0'
+
+
Index: package_tags/xvm-prodconfig/0.9/files/etc/xen/sysvms/xvm-2.mit.edu
===================================================================
--- package_tags/xvm-prodconfig/0.9/files/etc/xen/sysvms/xvm-2.mit.edu	(revision 1000)
+++ package_tags/xvm-prodconfig/0.9/files/etc/xen/sysvms/xvm-2.mit.edu	(revision 1000)
@@ -0,0 +1,38 @@
+
+# Configuration file for the Xen instance xvm-2.mit.edu, created
+# by xen-tools 3.8 on Sun Sep 28 19:19:08 2008.
+#
+
+#
+#  Kernel + memory size
+#
+kernel      = '/boot/vmlinuz-2.6.24-19-xen'
+ramdisk     = '/boot/initrd.img-2.6.24-19-xen'
+memory      = '128'
+
+#
+#  Disk device(s).
+#
+disk        = ['phy:xenvg/s_master_hda,hda,w']
+root 	    = '/dev/hda1 ro'
+
+#
+#  Hostname
+#
+name        = 'xvm-2.mit.edu'
+
+#
+#  Networking
+#
+vif         = [ 'ip=18.181.0.80,mac=00:16:3E:5F:C1:D4' ]
+
+#
+#  Behaviour
+#
+on_poweroff = 'destroy'
+on_reboot   = 'restart'
+on_crash    = 'restart'
+
+extra = '2 console=xvc0'
+
+